module Nastika 

class HTTP

  # Crafting get requests
  class Get
    attr_accessor :reqpath
    attr_accessor :headers
    attr_accessor :httpver

    # Intializes the Get object. 
    # Params:
    # +reqpath+:: Path to request
    # +httpver+:: HTTP version to use
    # +headers+:: Additional headers
    def initialize(reqpath=Nastika::Constants::DEFAULT_REQPATH,
                   httpver=Nastika::Constants::DEFAULT_HTTPVER,
                   headers=Nastika::Constants::DEFAULT_HEADERS)
      self.reqpath = reqpath
      self.headers = headers
      self.httpver = httpver
    end

    # Convert the object to a string.
    def to_s
      payload = ""
      payload += "GET #{self.reqpath} HTTP/#{self.httpver}\r\n"
      self.headers.each do |key, val|
        payload += "#{key}: #{val}\r\n"
      end
      payload += "\r\n"
      return payload
    end
  end

end
end