module Nastika 

class HTTP

  # HEAD request
  class Head
    attr_accessor :reqpath
    attr_accessor :headers
    attr_accessor :httpver

    # Initialize the Nasktika::HTTP object
    # Params:
    # +reqpath+:: Path to include in the request
    # +httpver+:: Http version to use. Default is 1.0
    # +headers+:: Any headers to send with the request.
    def initialize(reqpath=Nastika::Constants::DEFAULT_REQPATH,
                   httpver=Nastika::Constants::DEFAULT_HTTPVER,
                   headers=Nastika::Constants::DEFAULT_HEADERS)
      self.reqpath = reqpath
      self.headers = headers
      self.httpver = httpver
    end

    # Converts the request object to a string.
    def to_s
      payload = ""
      payload += "HEAD #{self.reqpath} HTTP/#{self.httpver}\r\n"
      self.headers.each do |key, val|
        payload += "#{key}: #{val}\r\n"
      end
      payload += "\r\n"
      return payload
    end
  end

end
end