module Nastika 

class HTTP

   # Crafting POST requests
   class Post
    attr_accessor :reqpath
    attr_accessor :headers
    attr_accessor :httpver
    attr_accessor :forminf

    # Initializes the object
    # Params:
    # +reqpath+:: the path to request
    # +httpver+:: the HTTP version to use
    # +headers+:: Additional headers to use
    # +forminf+:: Form information
    def initialize(reqpath=Nastika::Constants::DEFAULT_REQPATH,
                   httpver=Nastika::Constants::DEFAULT_HTTPVER,
                   headers=Nastika::Constants::DEFAULT_HEADERS,
                   forminf=Nastika::Constants::DEFAULT_FORMINF)
      self.reqpath = reqpath
      self.headers = headers
      self.httpver = httpver
      self.forminf = forminf
    end

    # Convert the object to a string
    def to_s
      payload = ""
      payload += "POST #{self.reqpath} HTTP/#{self.httpver}\r\n"
      self.headers.each do |key, val|
        payload += "#{key}: #{val}\r\n"
      end
      self.forminf.each_with_index do |(key, val), i|
        payload += "#{key}=#{val}"
        payload += "&" unless i == forminf.length-1
      end
      payload += "\r\n\r\n"
      return payload
    end
  end

end
end